\subsection{Recommender Systems}

\subsubsection{Introduction}

\icite{falk2019practical} defines a \acf{rs} as "[a system that] calculates and provides relevant content to the user based on knowledge of the user, content, and interactions between the user and the item."

For a long time recommendations were luxury created carefully by shop-owners, marketers and in general commercial businesses to provide a personalised experience to their customers. The process of this creation is tedious and infeasible for a big customer base. Thinking about any brick-and-mortar shop, besides the work of maintaining the shop, the staff would need to collect data about the customers, interpret this, link it with the range of goods available and present the items  with the best chance of getting bought without driving the customers away by being too intrusive. Furthermore, such a shop has to have the whole range of goods in stock, which is expensive and limited, thus it is hard to make recommendations really deviating far from the mainstream products.

This does not apply, however, to modern online shops. Webportals may reach thousands or millions of people, capturing all their browsing behaviour, inferring interests and suggesting from a myriad of goods, that most definitely not one single shop could have in stock. On those platforms it is also possible to recommend lots of \ac{fp} since the users are expecting a high \emph{recall} already.

Let us define the taxonomy used throughout this section to describe the system: domain,  purpose, context, personalisation level, whose opinions, privacy and
trustworthiness, interfaces, and algorithms \iacite{falk2019practical}.

\subsubsection*{Domain}

It describes the type of content to recommend. Depending on the type, recommendations may differ greatly. Movie recommenders for example may recommend a lot of \ac{fp}, but if the content is more critical like recommending foster parents to children, \emph{precision} should be maximised. Furthermore, it may be desired to get similar products suggested on a platform for baby products, especially if one wants to try many different recommendations before settling on a product. On the other hand in news recommenders it would be bad if the system recommends news articles from a different newspaper about a topic the user has already received. Furthermore, it would make not much sense recommending movies to a user that are only available in a language they can not understand or events that are too far away to be casually attended etc. Ultimately it is important to look very closely at the domain to make decisions about the recommendations that would make sense for the user base \iacite{falk2019practical}.

\subsubsection*{Purpose}

Purpose describes both what the users and the service providers expect of the system. When the user wants to get recommendations best matching their taste, the service provider may want to keep the customers to pay their subscriptions, or push specific items, because they earn more money thereof. Sometimes the purposes of both parties may align perfectly, but if not the service provider has to be careful to keep their users content \iacite{falk2019practical}.

\subsubsection*{Context}

The context refers to the immediate reason the user is using the recommender. It entails the devices the queries are made, the mood of the user etc. Users may have different tastes in music if at work or working on their hobby. Users may search for a coffee shop, but do they need one to have a good time with an acquaintance or because it is cold outside, or just started to rain. Does the user have enough time to watch a 2 hour movie at the moment or would a short episode of a series be more appropriate. The better the context is known, the more accurate the suggestions can be made \iacite{falk2019practical}.

\subsubsection*{Personalisation Level}

There are typically three levels of personalisation for recommendations:

\begin{itemize}
    \item Non-personalised content
    \item Semi-personalised content
    \item Personalised content
\end{itemize}

\emph{Non-personalised content} may refer to the most viewed items this week, or the top picks of the service provider, or even the most recent content added. This content is independent of a particular user and may thus be presented to all users uniformly. \emph{Semi-personalised content} is based on certain categorisations the system can make for the users. The system may not know anything about the user's tastes but may know which age group the user belongs to, gender, sensory data from mobile devices, including if the user is moving and receives thus different music suggestions, than if being stationary. For that users are clustered in multiple dimensions and the whole cluster or group receives then the same \emph{semi-personalised recommendations}. \emph{Personalised content}, meanwhile is truly generated from the user's data and for the user. What contributes here is the user's behaviour within the system, described in section~\ref{ss:behaviour}. Mostly because this behaviour generates implicit and explicit ratings for content, from which the taste can be inferred. This will be covered in section~\ref{ss:rating} \iacite{falk2019practical}.

\subsubsection*{Whose Opinions}

This refers to recommendations that are generated by experts. For some content it is \emph{accepted}, that experts give their opinion. An example could be a site suggesting wines. Most of the modern systems, however, use the opinion of the general majority \iacite{falk2019practical}.

\subsubsection*{Privacy and Trustworthyness}

It is important that the users trust the service and the recommendations. Many may think that they are being manipulated for getting analysed only to get suggested content with some latent motivation. If the motivation is clear to the user and does not collide with their opinion, trust is possible. If for some reason the service provider suggests items that bring more revenue, that are provided by lobbyists, or sell the users information to some third parties and the users notice this, the trust will be broken. When recommendations are done properly, and for the sake of bringing the right content to the customer, then users should not feel manipulated anymore, as that is exactly what they wanted \iacite{falk2019practical}.

\subsubsection*{Interface}

The interface of a recommender is defined by the input fed in and the output generated from it. A \ac{rs} may be fed by \emph{preference elicitation}, i.e. the users explicitly state which items interest them, by implicit behaviour like, clicking on an item or its description, watching a movie only half-way through and then dropping it, the shopping behaviour etc. A recommender may also output different kinds of data, like actual recommendations, predictions, filtering or ranking. Furthermore, a recommendation that is an integral part of the interface is called \emph{organic}. If it is additional information, that could easily be removed without changing the main interface of the system's current view, it is denoted \emph{inorganic}. A recommender explaining their recommendations, e.g. when Amazon states, that it suggests something because you own a specific item, is called a \emph{white-box recommender} and \emph{black-box recommender} otherwise \iacite{falk2019practical}.

\subsubsection*{Algorithms}

There are in fact three different types of \acp{rs}. \acf{cf} algorithms depend on usage data and \acf{cbf} algorithms employ item and user meta data. A combination of both is called a \emph{hybrid recommender} \iacite{falk2019practical}.

\subsubsection{User Behaviour}\label{ss:behaviour}

It is necessary, that for personalised recommendations for users, to get to know the user, learn their behaviour, record their interaction with the service and use that knowledge then to infer the user's preferences or taste. The information that is generated by the user and used as a basis for the recommendations is typically referred to as \emph{evidence}. This section describes how evidence is collected and stored and what types of evidence may exist or are worthy of collecting \iacite{falk2019practical}.

\subsubsection*{Evidence Collector}

One part of the \ac{rs} should be dedicated to collecting the evidence of all the users. The recommender part of the system can then query the \emph{evidence collector} for relevant information. To actually collect this evidence the \ac{rs} has a predefined interface that accepts events of 

\begin{itemize}
    \item[] \textbf{browsing}\\the user is exploring the content without an apparent reason or goal
    \item[] \textbf{interest manifestation}\\the user performs some action or series of actions that can be interpreted as being interested in an item or a collection of items
    \item[] \textbf{interest declaration}\\the user uses one of the defined methods to explicitly state that the item is interesting and will be consumed
    \item[] \textbf{item acquisition}\\the user purchases the item or initiates the consumaton
    \item[] \textbf{consumation}\\the user consumes the product
    \item[] \textbf{rating}\\the user rates the consumed product
    \item[] \textbf{disposing}\\the user disposes of the item either by deleting, marking it completed, reselling etc.
\end{itemize}

Every time the user performs one of the aforementioned actions, an event is sent from the application to the evidence collector, which in turn stores the evidence just generated. The recommender may then query this information, assigns a quality measure to the information and uses that for filtering and ranking decisions \iacite{falk2019practical}.

\subsubsection*{Shop Browsers}

Shop browsers refer to the role of users, exploring the content. The user tends then to look at many different items shallowly or more deeply. The browsing may even be free of any pattern to recognise. Important here is to collect the events in which the user opens up detailed information, stops to read descriptions, watching teasers or trailers, adds items to the watchlist or basket, any kind of interest manifestation should be noted and carefully recorded. It may also be beneficial to remember the items the user was seeing but not showing any interest in \iacite{falk2019practical}.

\subsubsection*{Page View}

Page views can have different meanings, one of which may be that the user is interested in the item, or still indecisive, that is why the user is coming back multiple times. It could also indicate that the user is a heavy consumer if many page views occur, or that the users are lost or unable to find what might be of interest to them. A small number of page views from the moment the user starts exploring the content until the item acquisition or consumption is usually a good measure of a good \ac{rs} \iacite{falk2019practical}.

\subsubsection*{Page Duration}

Dwelling on a page or pausing may be a good measure but it may be hard to know the exact reason why time is spent on a page, especially without any other user action performed. If users spend several minutes on a page, does this mean they are interested, or that they left their device unattended? When the user spent a considerable time browsing through the description of an item, what is the conclusion to be drawn? Did the description convince him that the item is of interest, or did it cause the exact opposite effect? It is important to know the domain and pair this information with other evidence collected to utilise this fully \iacite{falk2019practical}.

\subsubsection*{Expansion Clicks}

Many pages show a bare minimum information for the user to decide if an item may interest them or not and \emph{hide} additional information for the user to unhide when more information is needed. This may refer to the shortened description that can be expanded, the trailer that needs to be opened, the reviews for which the user needs to scroll to the bottom of the page etc. Most of the time it is a sign of interest when the user performs some kind of \emph{expansion click} \iacite{falk2019practical}.

\subsubsection*{Social Media Links}

People like to share their opinion and also on their favourite social media platform. Even though one cannot collect evidence from the platform itself, the act of sharing is noteworthy, as this also only happens if interest is present \iacite{falk2019practical}.

\subsubsection*{Save for Later}

This is a method for the user to \emph{declare} their interest in an item. Maybe the user casually encountered an item of interest but was looking for something else, or the user is browsing at the moment and collecting interesting items. In any case, the user can add the interesting items to some kind of list and review this list later \iacite{falk2019practical}.

\subsubsection*{Search Term}

When users want to find a specific item which is not in the recommendations they usually turn to the search functionalities of the services. This may be recorded as a failure for the recommender system as it failed to recommend something interesting enough and made the user turn to search themselves. It could also mean that the user wants to try something the system is not yet aware of. Either way, it is important to store this evidence and even if the content cannot be provided, given that it is not part of the range of goods, it should be remembered what kind of item the user was looking for to infer some taste from its meta information \iacite{falk2019practical}.

\subsubsection*{Buying}

Buying an item is mostly considered positive. It means the user shows some interest in that item. This could be because they want to consume the item themselves, but it could also indicate that it is a present for another person. At least if it does not coincide with the other purchases thus far, it may be recognised as an outlier and either utilised as a new kind of interest or disregarded until the interest manifests more clearly. If an item can or should be consumed regularly, the first purchase may indicate interest but not as much as the second purchase, which then is a clearer confirmation of that fact \iacite{falk2019practical}.

\subsubsection*{Consuming Products}

Consumption of products is probably the principal goal of the users. Thus consumption itself can be seen as the clearest indicator of interest thus far. In case this product is consumed off the service not much more can be recorded, but in case of digital products, like movies, music, ebooks etc. the process of the consumption can be analysed. How many times has the user interrupted the consumption and resumed? Was it consumed completely? How many times was the item consumed? Is it actually consumed or was it just bought or added to the \emph{save for later} list? One can see, there is much to gain from observing the actual act of consuming an item \iacite{falk2019practical}.

\subsubsection*{Ratings}

Visitor ratings are ratings the users are explicitly assigning a product, they assume matches their opinion of the product. Those user ratings can and should be used, but sometimes they do not align with the users actions and thus should be incorporated carefully. Mostly these ratings can be weighted by user behaviour. Some users for example may only rate items they do not like, that does not mean that they like every other item, furthermore if there is a predefined scale, for instance 5 stars, some users prefer to give higher ratings while others utilise the whole scale. To get some useful information from those ratings, the ratings have to be normalised and weighted against the user behaviour. Furthermore, rating gives the user a sense of control over how their recommendations turn out. This is important as users tend to feel less manipulated and self-actualised. Apart from the rating itself, it is also important to record the \emph{act} of rating, as this in itself shows that the user has some kind of interest in the item, regardless of its characteristic \iacite{falk2019practical}.

\subsubsection*{Voting - Reputation Systems}

Apart from ratings a different type of explicit rating is the voting. In this case it is a binary decision for a single item to be good or bad. Systems utilising votings to promote or demote items and even influence user behaviour. Systems centered around votes are called reputation systems. \icite{so.2019} described in section~\ref{ss:stackoverflow} is an example of such a reputation system \iacite{falk2019practical}.

\subsubsection*{Identifying Users}

User behaviour can only be collected when a user can be uniquely identified and tracked across sessions and devices. This is usually handled by user accounts. When a visitor first lands on the service they are first assigned a cookie to build a session and the evidence is collected anonymously, when the visitor converts then by registering, the data can be transferred to that user account \iacite{falk2019practical}.

\subsubsection*{Data from other Sources}

It may improve the system's understanding of the user, if the system collects data from other services like social media platforms. This data can be incorporated in the evidence already collected of the user and the meta data the user themselves filled out \iacite{falk2019practical}.

\subsubsection{Monitoring}

As raised in the previous section, evidence alone does not suffice in determining someones preferences. Therefore, the evidence generated has to be set in context of its creation. With the context available, assumptions can be drawn that form the preference of the user. These assumptions then have to be integrated, tested, validated and adapted if incorrect \iacite{falk2019practical}.

\subsubsection*{Key Performance Indicators}

First, let us describe \acp{kpi}. A \ac{kpi} is a measure from which the performance of the service can be determined. By clarifying which goals the service should achieve for the service provider, \acp{kpi} can be defined and data, to compute them, can be gathered. These \acp{kpi} will be used to validate the assumptions drawn and indicate whether the system has to be adapted or not \iacite{falk2019practical}. 

\subsubsection*{Analytics}

Analytics is the act of processing data to discover and draw latent information. For that the data may be filtered, aggregated, transformed or otherwise manipulated to generate new \emph{analytics data}. Analytics is called \emph{off-site} if it is \emph{not} generated from data within the application, and \emph{on-site} otherwise. \emph{Off-site analytics} is divided into three categories

\begin{itemize}
    \item[] \textbf{Opportunity}\\describes the potential the application has
    \item[] \textbf{Visibility}\\describes how easy it is to find the application
    \item[] \textbf{Voice}\\describes how much the service is talked about
\end{itemize}

\emph{On-site analytics} is generated from data collected within the service. Recommenders need \emph{on-site analytics} to compute the \acp{kpi}. Important \acp{kpi} may include among others

\begin{itemize}
    \item[] \textbf{Number of visitors per week}
    \item[] \textbf{Sessions per day}
    \item[] \textbf{Items sold/consumed}
    \item[] \textbf{Items viewed}
    \item[] \textbf{Conversions}
\end{itemize}

By benchmarking this \acp{kpi} regularly, one can easily determine if the system is improving \iacite{falk2019practical}.

\subsubsection*{Dashboard}

It is important to regularly inspect the analytics and act upon them. The system could be in its early phases and no assumptions are proven yet, or there could be a shift in the usage of the system influenced by trends, that suddenly worsen the \acp{kpi} defined. Whatever the reason is, it is important to always know how the system performs. Therefore, it is essential to present the data in an easy way and give quick overviews that can be captured easily. A dashboard, therefore, is some kind of view on the analytics data, that presents the \acp{kpi} in a graphical representation, that let one determine the \ac{rs} performance immediately. This will then be the main tool to work with the analytics data and work upon it \iacite{falk2019practical}.

\subsubsection{Explicit and Implicit Ratings}\label{ss:rating}

\subsubsection*{Explicit Ratings}

As mentioned previously, items can be rated explicitly or implicitly. The former is a method for the user to express their subjective opinion, giving them some sense of control and acquiring a very obvious measure about the users sentiment towards the item. The user's explicit ratings are influenced by a lot of factors, which have to be taken into account when using this information for recommendations. For one, the ratings may only use part of the rating scale, that could mean that the user only rates items that fall into that sentiment, or that the user for instance does not like to give negative ratings, that the user only rates negative items or that the ratings are skewed by some kind of self-delusion because of external influences like friends. Furthermore, explicit ratings can be adapted over time, so a user may come to like an item that was negatively rated for years, or rated the item before even consuming it and changing their opinion after they then did after all. This means, an explicit rating has to be preprocessed before it can be used as a value in the ratings computation \iacite{falk2019practical}.

\subsubsection*{Implicit Ratings}

Implicit ratings are generated by user behaviour. These ratings could usually be trusted as they are authentic in a sense, that they are usually not faked subconsciously by the user. They act in their best interest in mind until they reach their goal of acquiring an interest item. The whole pipeline the user walks through to get there, generates implicit ratings in form of evidence. Evidence was covered in section~\ref{ss:behaviour}. Using that evidence it is now possible to calculate a rating score. As not all of the user behaviour is equally indicative of the interest, the user shows in that item, it is good practice to weight the occurrence of an event accordingly. The weights can be determined looking at the analytics generated. For example for a commercial website, it may be possible to determine how much an event contributes to a purchase by calculating the number the events occurred for a specific item and led to a purchase, compared to the number of the same kind of events not leading to a purchase. A simple example to evaluate would be the event of a purchase itself. As an event to purchase inevitably leads to a purchase, the weight for such an event could be $1.0$, while the event for an expansion click on the description of an item could be weighted by $0.5$ if half of the expansion clicks of items actually lead to purchases. Furthermore, it should be considered if multiple instances of the same event should influence the rating. If a user visited an item's detail page 3 times, is this more indicative of their interest, than when they visited it 10 times? \iacite{falk2019practical}.

\subsubsection*{Rating Computation}

Let $E$ be the number of events to contribute to the implicit rating $IR_{ui}$ of user $u$ and item $i$. $e$ is an instance of a specific event. Furthermore, $w_e$ denotes the weight applied to the evidence collection of $e$. The number of events that occurred for user $u$ and item $i$ is calculated by $c: e,u,i \rightarrow \textrm{N}$. Then the normalised implicit rating can be obtained by the equation

\begin{equation}
    IR_{ui}=\sum_e^E w_e*c(e,u,i)
\end{equation}
\equationlistentry{Implicit Rating}

Let the inverse user frequency $iuf_i$ be calculated by the equation~\ref{eq:iuf}

\begin{equation}\label{eq:iuf}
    iuf_i=log\left(\frac{N}{1+n_i}\right)
\end{equation}
\equationlistentry{Inverse User Frequency}

where $N$ is the total number of users and $n_i$ is the number of users, that have rated item $i$. Then the weighted implicit rating is

\begin{equation}
    wIR_{ui}=IR_{ui}*iuf_i=IR_{ui}*log\left(\frac{N}{1+n_i}\right)
\end{equation}
\equationlistentry{Weighted Implicit Rating}

To promote freshness of ratings, because interest may shift over time, the evidence collection function may be calculated as follows

\begin{equation}
    c(e,u,i)=\sum_j^J \frac{1}{days~since~time~of~event_j}
\end{equation}
\equationlistentry{Evidence Collection Function}

$J$ being the number of events obtained by event type $e$, for user $u$ and item $i$. Here the freshness value of the events are summed up and thereafter the obtained implicit rating can be combined with the normalised explicit rating \iacite{falk2019practical}.

\subsubsection*{User-Item-Matrix}

When an item is rated, the rating can be put into a user-item-matrix. This is a sparse matrix that shows the ratings of all users for all items in the catalog. This is usually used to calculate the recommendations and the similarity between users \iacite{falk2019practical}.

\subsubsection{Non-Personalised Recommendations}

What should be recommended when there is no data available for some users because they just registered or there are no good recommendations anymore because everything suggested to them was already consumed or disregarded? There are many cases why this would be an interesting problem, but in essence, a recommender system should not only suggest personalised content but also content for exploration. Even if there are lots of recommendations for a user they could feel adventurous an try to explore new things.

A non-personalised recommendation is not generated from one user or group but from the data of the whole user base. Every top-n chart on any service is such a case. A few examples would be: \emph{the top-10 asked questions, the top-10 drama movies and the top-10 most liked photos.} The \emph{n} can naturally be replaced by any number. Such charts, represent the general consensus of the user base and there is a high probability that a user might find something in these lists. Another type of non-personalised content comes from seeded recommendations. That means that the recommendation is based on content the user is currently looking at regardless of their taste. Supposing a user is looking at an item at a commercial website, the website may recommend other items, that pair well with this item like \emph{phones and cases, power banks and cables, a shirt and a skirt etc.} This pairing information may be obtained by similarity measures, or by linking purchase histories together, but this usually does not reveal any information about any user tastes. These recommendations are based solely on the items \iacite{falk2019practical}.

\subsubsection{Cold-Start}

Recommendation only works if data is available. When a new user visits the site or registers, the system does not know anything about the new user. Therefore, no personalised recommendations can be made. This is called a \emph{cold-start problem}. The same applies to items newly introduced to the system. These new items, have no votes, ratings or connections to any other items or users, thus those new items may not be considered for recommendations. Furthermore, if a user's preferences are too specific the same problems arise, as if it was a new one. These users are called \emph{gray sheep}. Coping with the \emph{cold-start} and \emph{gray sheep problems} has been a long-standing problem. The two methods generally used are to inquire the user's preferences and using association rules to fake the preferences.

The former case can be solved by a method called \emph{preference elicitation}, in which the user will be presented with a \emph{quiz} that smartly deduces the user's preferences. Thinking of a movie site, this could mean that the users have to select movies from a list they are interested in. The system then has to find a good balance between similar items and very distant ones, to get a broad understanding of a user's preferences. This method may scare customers away if not done carefully. Users usually want to get to know the service first and be presented with good recommendations without first having to answer a lot of questions. Still this method probably is the best method to learn about the user and should at least be made optional if possible.

The second method tries to make associations between the user and other users, or items the user is browsing at the moment and other items. If the user registered and had filled out demographic information, it is possible to find users with similar demographic information and recommend the most popular items from that group. Similar it would be possible to remember the browsing items and use them as a seed, as discussed in the previous section. These association rules however, may need domain specific restrictions. If a user likes cartoons and horror movies, it may not be a good idea to recommend horror movies to a new user that is a child \iacite{falk2019practical}.

\subsubsection{Similarities}

Similarity measures are used to rank items to how much they are alike to others. When a \ac{rs} returns all items in the set, unordered at that, the user will be overloaded with information and unable to choose, or at least to choose the best items thereof. Similarity for \ac{rs} can be calculated from the associations between users and items, meaning $user_a$ is similar to $user_b$ when they like the \emph{same} items, i.e. with the user-item-matrix as a base, or by comparing the content of the items, e.g. $user_a$ and $user_b$ are similar if they have similar information or if they like \emph{similar} items. Notice, that in the first case the similarity comes from the association itself; the items are the same. In the second case, the association may not be about sentiment but item-similarity and the users do still relate to each other, because their items are similar to each other. Usually the data can be presented in some kind of matrix format, if its the user-item-matrix, containing the rankings of all the users for all the items, or the document vectors describing the text features. In this case there are several algorithms calculating similarity with different properties. The $L_1-norm$ for example is the absolute difference between two vectors and is defined as

\begin{equation}
    L_1(i,j)=\sum_{i=1}^n\vert r_i - r_j \vert
\end{equation}
\equationlistentry{$L_1-norm$}

The \ac{mae} is an extention of the $L_1-norm$ for which the average is calculated.

\begin{equation}
    MAE(i,j)=\frac{1}{n}\sum_u\vert r_{i,u} - r_{j,u} \vert
\end{equation}
\equationlistentry{\acf{mae}}

The next measure for two vectors is the $L_2-$ or \emph{Euclidian-norm} and is defined by the equation~\ref{eq:l2}.

\begin{equation}\label{eq:l2}
    L_2(i,j)=\left \|r_i - r_j\right \|_2=\sqrt{\sum_u\vert r_{i,u} - r_{j,u} \vert^2}
\end{equation}
\equationlistentry{$L_2-norm$}

While the former is measuring the distance along the axis of the cartesian system, the latter is defining the distance as the shortest path between the two vectors. The $L_1-norm$ is thus, also called the $Manhatten-distance$. When the feature vectors of elements are projected into the cartesian coordinate system, one could also look at the angle between the feature vectors to define the similarity between two items. One such measure is the \emph{cosine similarity measure}. It is defined by equation~\ref{eq:cosine}.

\begin{equation}\label{eq:cosine}
    sim_{cos}(i,j)=\frac{r_i\cdot r_j}{\left\|r_i\right\|_2\left\|r_j\right\|_2}=\frac{\sum_u r_{i,u} r_{j,u}}{\sqrt{\sum_u r_{i,u}^2}\sqrt{\sum_u r_{j,u}^2}}
\end{equation}
\equationlistentry{Cosine Similarity}

When the values of the vectors are not normalised, e.g. the skewed arbitrary ratings of users, the \emph{cosine similarity measure} can be turned into \emph{Pearson's correlation coefficient}.

\begin{equation}
     sim_{pears}(i,j)=\frac{\sum_u(r_{i,u} - \bar{r}_u)(r_{j,u} - \bar{r}_u)}{\sqrt{\sum_u(r_{i,u} - \bar{r}_u)^2}\sqrt{\sum_u(r_{j,u} - \bar{r}_u)^2}}
\end{equation}
\equationlistentry{Pearson's Correlation Coefficient}

Which measure to choose from depends on the similarity problem \iacite{falk2019practical}.

\subsubsection{Collaborative Filtering}

\acf{cf} is the family of recommendation algorithms concerned with predicting ratings for \emph{not-yet-rated items} by association. Supposing one wants to watch a movie but is not sure which of the movies would be good. The person can ask their friends or family for advice. When they return their opinion (rating), the person can decide, if the recommender has similar taste and by extension whether the recommendation might be accurate. The same applies if the person wants to read a book and looks at the books in ones shelf which were good reads and tries to find books with similar genre, synopsis or from the same author. When the books then are similar enough the rating might be transitive and accurate.

\subsubsection*{User-User and Item-Item}

 The two methods used in these examples are denoted as \emph{user-user} and \emph{item-item recommendations}. The two approaches are shown in figure~\ref{fig:cf-types}. The process going right-down, describes the steps taken to recommend by user-similarity, while down-right by item-similarity.

\image[
    label=fig:cf-types,
    caption=User-user and item-item \acf{cf} recommendation steps \iacite{falk2019practical}.,
    width=0.6\textwidth
]{images/cf-types}

As a \ac{rs} may have a lot of users and items, it is very important to decide which approach might be more efficient. Usually, it is better to use \emph{item recommendations}, when there are fewer items and more users. If the opposite is true, \emph{user recommendations} should be used. If the system is very sparse, however, \ac{cf} may not be a good choice at all, as with no rated content, no recommendations can be made \iacite{falk2019practical}.

\subsubsection*{Calculating Recommendations}

To find recommendations in \ac{cf} systems, it is required to fill the gaps in the user-item matrix. The gaps, are the items, the user has not rated yet, neither explicitly nor implicitly. Thus, they are potential candidates for recommendations. To infer ratings for these gaps the algorithm for user-user and item-item recommender is the same, except for the items that that are compared, or in the sense of the user-item matrix, if one looks at the columns or the rows. For the user recommendation, one looks at users for which the recommendations should be created and identifies the gaps. Then for all the other users the similarity is calculated by using the columns as feature vectors, i.e. for every user, the ratings of all items. The users are then ordered by this similarity value, to have the most similar users on top of the list. A neighbourhood is then chosen, that chooses some items from the top and uses the rating for the gap-item, of those users, as a base to determine the rating for this user. The process is the same for the item recommender, except for using the items similarity and choosing thereof a neighbourhood, to predict the new rating. This processes are display in the figure~\ref{fig:calc-cf-types} \iacite{falk2019practical}.

\doubleimage[
    label=fig:calc-cf-types,
    caption={Shows the two different approaches of user-user and item-item \ac{cf} in the four steps of 1) calculating similarity 2) ordering according to similarity 3) choosing the neighbourhood 4) calculating the rating from the chosen neighbourhood.},
    captiona={User-user recommendation steps. Step 1 is calculating the similarity of the active user to other users, that have rated the item\\ \iacite{falk2019practical}.},
    captionb={Item-item recommendation steps. Step 1 is calculating the similarity of the rating for the current item to the other items \iacite{falk2019practical}.}
]
{images/user-user-cf.png}
{images/item-item-cf.png}

\subsubsection*{Neighbourhoods}

There are typically three types of neighbourhoods to determine the top elements, which are by \emph{clustering, top-n} and \emph{threshold}.

\begin{itemize}
    \item[] \textbf{Clustering}\\
    Clustering is the process of dividing the data into several separate groups, so that no item is part of multiple groups. Clustering algorithms do not have to be deterministic and so it is important to find a good configuration to find clusters, that really contain similar items. For this approach of choosing a neighbourhood, a cluster could serve as the neighbourhood to choose from. Therefore, the cluster size should be relatively small.
    \item[] \textbf{top-n}\\
    This approach is very simple. A predefined $n$ is chosen and the neighbourhood is defined as the top $n$ items from the ordered list of users, or items.
    \item[] \textbf{threshold}\\
    Using a threshold as a neighbourhood means to define a threshold value and compare all the similarity values of the ordered list with that threshold. At one point all elements should be below the threshold, since the list is ordered, and thus all the items below this threshold are dropped.
\end{itemize}

It is important to choose the right neighbourhood. It could happen that in the \emph{top-n} are actually only elements that are not very similar, because none of the other items are similar to the item the recommender was comparing. Then again, if the threshold is so high, that it strips away all the items, again, no predictions can be made \iacite{falk2019practical}.

\subsubsection*{Calculating Predictions}

After a neighbourhood has been chosen, the ratings have to be predicted. There are two classical ways to create predictions, namely \emph{regression} and \emph{classification}. The former calculates the average of other ratings while the latter chooses the most used rating. For item-based predictions for example the regression approach would calculate the predicted ratings by the weighted average as depicted in equation~\ref{eq:pred_ratings}.

\begin{equation}\label{eq:pred_ratings}
    Pred(u,i)=\bar{r}_u+\frac{\sum_{j\in S_i}(sim(i,j)\times r_{u,j})}{\sum_{j\in S_i}sim(i,j)}
\end{equation}
\equationlistentry{Predicted User Rating}

Here $Pred(u,i)$ is the predicted rating, $\bar{r}_u$ is the average rating of user $u$. $S_i$ denotes the set of items in the neighbourhood of item $i$. $sim(i,j)$ determines the similarity between item $i$ and $j$ and $r_{uj}$ is the rating of user $u$ for the item $j$ \iacite{falk2019practical}.

\subsubsection*{Creating Recommendations}

To create recommendations, the items with the \emph{predicted ratings} are ordered and the top rated ones can be returned as recommendations. If a view for recommendations can only hold a specific number of recommendations the top-n best rated would be chosen. It may be good to exclude ratings if they are below average even if they are in the top-n \iacite{falk2019practical}.

\subsubsection{Content-Based Filtering}

\acf{cbf} compared to \ac{cf} does not use ratings and associations to generate recommendations but the item's content instead. Items are usually made up of information. This could be structured, semi-structured or unstructured. The information can be further divided in two categories: \emph{facts} and \emph{tags}

While facts are information that stem from truth, for example the production year of a movie, tags are assigned to an item based on creativity, subjectivity and for classification reasons. Two people may tag the same item with different tags and both collections of tags may be appropriate. This means that tags usually have to be normalised and carefully used as a basis for similarity measures.

The \ac{cbf} system consists of three parts

\begin{description}
    \item[] \textbf{Content Anlyzer} Extracts information from the items
    \item[] \textbf{User Profiler} Models a user profile that contains information about the user; such as consumed items etc.
    \item[] \textbf{Item Retriever} Compares the user profiles to the items, to generate recommendations
\end{description}

The next few sections describe the three parts in more detail \iacite{falk2019practical}.

\subsubsection*{Content Analyzer}

The content analyzer most of the time performs heavy work on the items when they enter the system or get changed. Therefore the content analyzer mostly works offline, meaning it works not within the live system. The offline generated information is then fed to the live system and ready for utilisation. Depending on the items, the content analyzer has to perform different tasks, like extracting meta information, processing natural language as described in section~\ref{ss:nlp}, tagging the items with additional information etc. Important is, that the content analyzer transforms the items into a mathematical form, that can be used for further computations, i.e. similarity calculations, by the system \iacite{falk2019practical}.

\subsubsection*{User Profiler}

A user profile is a model containing information about the user. In the case of \ac{rs}, it encodes information about unseen items of the user. Thus, it precalculates the similarities and the ratings and populates the model with that information, so that recommendations can be fetched very fast on demand.

Two examples of user models could be generated by using \ac{lda} and \ac{tfidf} models. In case of the former, for a user 
\begin{enumerate}
    \item fetch all consumed items
    \item find similar items using \ac{lda}'s topic distributions
    \item calculate a predicted rating based on the similarity and the rating of the consumed item
    \item order by rating
    \item order by relevance (if data is available)
\end{enumerate}

Recommendations can then be retrieved immediately from this ordered list in the user model. In case of the \ac{tfidf} model, it would be possible to look at all the document/item vectors of the consumed items and multiply each by their rating and add all the resulting vectors up. Thereafter the \emph{user profile vector} needs to be normalised to match the scale of the items \iacite{falk2019practical}.

\subsubsection*{Item Retriever}

The \ac{rs} does not always show the best recommendations for the user over all the items. In some cases it makes sense to only recommend items that fulfill a certain criteria. On a movie streaming platform it would make sense to present multiple sections with different recommendations, e.g. by genre (drama, comedy), by actor or more specific like categories \emph{"Because you have watched..."} or \emph{"Because you like..."}. In this case the user models ordered list is ranked again or filtered for a subset that matches the exact recommendation that is needed for the specific view to present them. This has the advantage to give the user again a sense of control as mentioned before, because the data is indeed filtered to avoid information overload, but the users can still choose which category they want to select the recommendations \iacite{falk2019practical}.

\subsubsection{Hybrid Recommenders}

\ac{cf} recommenders fare good when there are already many ratings available but does not account for the similarity between the items themselves. \ac{cbf} recommender are able to find similar items but discounts the popularity of them. So even if two items are similar one may still be bad quality-wise. To account for the strengths and weaknesses, of not only the different categories, but the different approaches, \emph{hybrid recommenders} were born. This is not a simple approach itself, but a family of approaches to combine different recommenders or their features to gain something new. Some categories of \emph{hybrid recommenders} will be presented below \iacite{falk2019practical}.

\subsubsection*{Monolithic Recommenders}

These are recommenders incorporating approaches and methods from multiple other recommenders, mixing and gluing them together and creating something new. The result does not resemble the parts it was borrowing the features of. Sometimes new steps are introduced to these to improve their effectivity further or account for weaknesses. An example would be to create a \ac{cf} system, that takes the similarity of items into account before predicting the ratings \iacite{falk2019practical}.

\subsubsection*{Mixed Recommender}

These are systems that wrap around a collection of other recommenders. Therefore first the most personalised ones are run like \ac{cf} and \ac{cbf} and therafter they gradually become semi-personalised and then unpersonalised. All the recommendations are ordered from most presonalised to not personalised and then the top-n are returned. This ensures that there are always enough recommendations to not get any empty results for the user \iacite{falk2019practical}.

\subsubsection*{Ensemble Recommender}

Ensemble recommender are similar but different to mixed recommenders, in the sense, that they again combine full recommenders but are smart about how to use the outcome. When two recommenders return the same item, what rank should it receive? This could be solved again by regression or classification. Furthermore these types of recommenders could weight their parts according to training with linear regression or with functions following some rules. The equation for the predicted rating of a \ac{fwls} ensemble recommender is

\begin{equation}
    r_{FWLS}(u,i)=\sum_{j=1}^L\sum_{k=1}^Mv_{kj}f_k(u,i)g_j(u,i)
\end{equation}
\equationlistentry{\acf{fwls}}

Here $r_{FWLS}(u,i)$ is the predicted rating of item $i$ for user $u$. $g_j$ is the predicted rating of recommender $j$. $f_k$ is a feature function, that returns if a condition was met or not and $v_kj$ is the weight of the feature. Suppose a \ac{cbf} recommender should provide $90\%$ of the rating when there are fewer than three items rated by the user, otherwise there should be a $50\%/50\%$-split. Furthermore, the feature functions $f_1$ and $f_2$ are as follows

\begin{equation}
    f_1(u,i)=1
\end{equation}

and the second

\begin{equation}
    f_2(u,i)=
    \begin{cases}
    1 & \textrm{if u has rated less than 3 item} \\
    0 & otherwise
    \end{cases}
\end{equation}

Then the weights can be assigned as $v_{11}=0.5, v_{12}=-0.4, v_{21}=0.5, v_{22}=0.4$. The following is the applied result

\begin{equation*}
    r_{FWLS}(u,i)=(0.5\times f_1(u,i)+-0.4\times f_2(u,i))r_{cf}+(0.5\times f_1(u,i)+0.4\times f_2(u,i))r_{cbf}
\end{equation*}

Thus, when the user has rated less then three items, it turns into

\begin{equation*}
    r_{FWLS}(u,i)=(0.5\times 1+-0.4\times 1)r_{cf}+(0.5\times 1+0.4\times 1)r_{cbf}
\end{equation*}

And finally to 

\begin{equation*}
    r_{FWLS}(u,i)=(0.1)r_{cf}+(0.9)r_{cbf}
\end{equation*}

In the other case, that the user has rated more than two items the result is $r_{FWLS}(u,i)=(0.5)r_{cf}+(0.5)r_{cbf}$, exactly what was defined. Like this a complex system of features can be composed and weighted that smartly returns ratings that adapt to the situation of the user or other factors. These weights can again be determined by linear regression \iacite{falk2019practical}.

\subsubsection{Ranking}

Until now all the recommendation lists returned by the recommenders, where ranked according to the ratings received and these were based on the popularity or similarity to already consumed or liked items. Sometimes however, other factors are more important. Taking location-based items into account, a café that is not too far away and has a good rating will probably be frequented by the customer, but if it has an excellent rating and is too far away it should be ranked lower because the customer might or even cannot go there. Hence, ranking has to be domain-specific. The same idea applies to timed events. It makes little sense to recommend events to attend, when they are in the past or far in the future, when the user just wants to have fun this one night or the day after, therefore closeness can be a factor that promotes or demotes a ranking \iacite{falk2019practical}.